# ReadKeyValueRepo

interface ReadKeyValueRepo < Key , Value > : Repo (source)

Read part of KeyValueRepo

#### Parameters

Key

This type will be used as key in all operations related to searches of data

Value

This type will be used as returning data in most "get" operations

#### Inheritors

KeyValueRepo
DelegateBasedKeyValueRepo
ReadMapKeyValueRepo
MapKeyValueRepo
ReadKeyValueCacheRepo
AutoRecacheReadKeyValueRepo
FullReadKeyValueCacheRepo
FullKeyValueCacheRepo
MapperReadKeyValueRepo
MapperKeyValueRepo
ReadKeyValueFromCRUDRepo
ReadKeyValueFromKeyValuesRepo
KtorReadKeyValueRepoClient
FileReadKeyValueRepo
FileKeyValueRepo
AbstractExposedReadKeyValueRepo
ExposedReadKeyValueRepo

## Functions

asReadCRUDRepo
Link copied to clipboard
fun < K , V > ReadKeyValueRepo < K , V >. asReadCRUDRepo (): ReadCRUDFromKeyValueRepo < V , K >
asReadKeyValuesRepo
Link copied to clipboard
fun < K , V , VI : Iterable < V >> ReadKeyValueRepo < K , VI >. asReadKeyValuesRepo (): ReadKeyValuesFromKeyValueRepo < K , V , VI >
cached
Link copied to clipboard
fun < Key , Value > ReadKeyValueRepo < Key , Value >. cached (kvCache: KVCache < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): ReadKeyValueCacheRepo < Key , Value >
fun < Key , Value > ReadKeyValueRepo < Key , Value >. cached (kvCache: KeyValueRepo < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): FullReadKeyValueCacheRepo < Key , Value >
contains
Link copied to clipboard
abstract suspend fun contains (key: Key ): Boolean
count
Link copied to clipboard
abstract suspend fun count (): Long
get
Link copied to clipboard
abstract suspend fun get (k: Key ): Value ?
getAll
Link copied to clipboard
open suspend fun getAll (): Map < Key , Value >
keys
Link copied to clipboard
abstract suspend fun keys (pagination: Pagination , reversed: Boolean = false): PaginationResult < Key >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys

open suspend fun keys (v: Value , pagination: Pagination , reversed: Boolean = false): PaginationResult < Key >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys.

maxPagePagination
Link copied to clipboard
inline suspend fun ReadKeyValueRepo <*, *>. maxPagePagination (): SimplePagination
values
Link copied to clipboard
abstract suspend fun values (pagination: Pagination , reversed: Boolean = false): PaginationResult < Value >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys

withMapper
Link copied to clipboard
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValueRepo < ToKey , ToValue >. withMapper (mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >): ReadKeyValueRepo < FromKey , FromValue >
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValueRepo < ToKey , ToValue >. withMapper (noinline keyFromToTo: suspend FromKey .() -> ToKey = { this as ToKey }, noinline valueFromToTo: suspend FromValue .() -> ToValue = { this as ToValue }, noinline keyToToFrom: suspend ToKey .() -> FromKey = { this as FromKey }, noinline valueToToFrom: suspend ToValue .() -> FromValue = { this as FromValue }): ReadKeyValueRepo < FromKey , FromValue >